[indent=4]

uses 

    Gtk



param_width : int

param_height : int

param_title : string

param_url : string



init

    param_url=args[1]


    if param_url == "--help"

        print "Usage: 'url' 'title' width height"
        return

    Gtk.init (ref args)

    if args.length > 1
        param_url=args[1]
    else
        param_url = "http://google.com"

    if args.length > 2
        param_title=args[2]
    else
        param_title = "HTML-viewer"

    if args.length > 3
        param_width=args[3].to_int()
    else
        param_width = Gdk.Screen.width() /2

    if args.length > 4
        param_height=args[4].to_int()
    else
        param_height = Gdk.Screen.height()-100
    


    var window1 = new Gtk.Window (Gtk.WindowType.TOPLEVEL) 
    window1.set_default_size ( param_width , param_height ) 
        
    window1.destroy += Gtk.main_quit 
    window1.set_title(param_title) 
    window1.move(0 , 40) 
  
    var vbox = new Gtk.VBox(false , 1) 
    vbox.border_width = 3 
    vbox.spacing = 4 
    vbox.show()
    window1.add (vbox) 
    
    //-- this path does not need to exist, but must be set to avoid crashes --

    MozEmbed.set_profile_path("/root/.mozilla/default/" , "MU")
    
    //MozEmbed.set_profile_path("/root/.mozilla/default/" , "r3y1skkw.slt")
    
    var hw = new HtmlViewerWindow ()
    hw.init()
    vbox.pack_start(hw.vbox,true , true ,0)
    
    hw.urlentry.set_text(param_url)
    
    window1.show_all ()

    Gtk.main ()

class HtmlViewerWindow : Window

    back_button: ToolButton

    forward_button: ToolButton

    quit_button: ToolButton

    moz: MozEmbed

    vbox : VBox
    urlentry :  Entry

    def init()


        create_widgets ()

        connect_signals ()

        

    def create_widgets () 

        var toolbox = new HBox(false , 0)
        toolbox.spacing = 10
        
        var toolbar = new Toolbar ()

        //quit_button = new ToolButton.from_stock (STOCK_QUIT)

        back_button = new ToolButton.from_stock (STOCK_GO_BACK)

        forward_button = new ToolButton.from_stock (STOCK_GO_FORWARD)

        //toolbar.add (quit_button)

        toolbar.add (back_button)

        toolbar.add (forward_button)
        
     
       
        moz = new MozEmbed ()

        

        moz.load_url(param_url)

        vbox = new VBox (false, 0)

        toolbox.pack_start (toolbar, true, true, 0)

        vbox.pack_start(toolbox , false , false , 0)
        
        //var spacer = new Label("     ")
        //toolbox.pack_start (spacer , false , false , 0)   
        
        urlentry = new Entry()
        toolbox.pack_start (urlentry , true , true , 0)  
        urlentry.activate += goto_url

        var spacer = new Label("  ")
        toolbox.pack_start (spacer , false , false , 0)  
        
        //var gobutton = new Button.with_label("go")
        //toolbox.pack_start (gobutton , false , false , 0)  
        //gobutton.clicked += goto_url
        
        vbox.add (moz)

    def goto_url()

        moz.load_url(urlentry.get_text())


    def connect_signals () : void

        //destroy += Gtk.main_quit

        //quit_button.clicked += Gtk.main_quit

        back_button.clicked += this.moz.go_back

        forward_button.clicked += this.moz.go_forward

        
/*
    def private update_buttons () : void

        back_button.sensitive = moz.can_go_back ()

        forward_button.sensitive = moz.can_go_forward ()
*/      
        